# -*- coding: utf-8 -*-
#Mox Local to World  190726 ノード名が重複するものに対してエラーがでる問題を対処
import maya.cmds as cmds

shapeList = ["Locator", "cube", "circle8", "rombus", "pyramid",]

#ロックをまとめて！
def locks(node, t=False, r=False, s=False, v=False):
    if t:cmds.setAttr(node+'.t', lock=True)
    if r:cmds.setAttr(node+'.r', lock=True)
    if s:cmds.setAttr(node+'.s', lock=True)
    if v:cmds.setAttr(node+'.v', lock=True)

#テキストフィールドから時間を取得（使ってないぜ！ ）  
def setTimefield(mode):
    if mode=="start":
        startF = cmds.playbackOptions(q=True,minTime=True)
        cmds.intField("start", e=True, v=startF)
    elif mode=="end":
        endF = cmds.playbackOptions(q=True,maxTime=True)
        cmds.intField("end", e=True, v=endF)

#メイン
def main(mode):
    shapeType = cmds.optionMenu('ShapeType', q=True, v=True)
    startF = cmds.playbackOptions(q=True,minTime=True)
    endF = cmds.playbackOptions(q=True,maxTime=True)
    
    #if cmds.checkBox("timeslider", q=True, v=True):
        #startF = cmds.playbackOptions(q=True,minTime=True)
        #endF = cmds.playbackOptions(q=True,maxTime=True)
    #else:
        #startF = cmds.intField("start", q=True, v=True)
        #endF = cmds.intField("end", q=True, v=True)
    attList = []
    worldCtrlList = []
    pcList = []
    selList = cmds.ls(sl=True)
    size = cmds.floatField("ctrlsize", q=True, v=True)
    
    for sel in selList:

        if cmds.objExists(sel+"_World") ==True:cmds.warning(sel+u"は、すでにワールド制御になっていませんか？") 
        if sel.count("_World"):cmds.warning(u"「_World」　の含まれるノードでは実行できません。") 
          
    
        else:
            #作ったロケーターのリストを作ります。
            if "|" in sel:
                worldCtrl = createCurve(shapeType, sel.split("|")[-1] +"_World", size)
            else:
                worldCtrl = createCurve(shapeType, sel+"_World", size)
            worldCtrlList.append(worldCtrl)
            
            if mode=="point":
                attList.append(worldCtrl+".t")
                pcList.append( cmds.pointConstraint(sel, worldCtrl)[0] )
                locks(worldCtrl, r=True, s=True, v=True)
                
            if mode=="orient":
                attList.append(worldCtrl+".r")
                pcList.append( cmds.orientConstraint(sel, worldCtrl)[0] )
                cmds.pointConstraint(sel, worldCtrl)
                locks(worldCtrl, t=True, s=True, v=True)
                
            if mode=="parent":
                attList.extend([worldCtrl+".t",  worldCtrl+".r"])
                pcList.append( cmds.parentConstraint(sel, worldCtrl)[0] )
                locks(worldCtrl, s=True, v=True) 
    
    bs = cmds.checkBox("bakeSimulation", q=1, v=1)
    sbtime = cmds.intFieldGrp("sampleBy", q=1, v1=1)
    cmds.bakeResults(attList, t=(startF,endF), simulation=bs, sampleBy=(sbtime) )
    cmds.delete(pcList)
    """
    #sbtimeが2以上なら最後のキーだけ手動で作る
    if sbtime >= 2:
        if mode=="point":
            cons = cmds.pointConstraint(sel, worldCtrl)[0]
            cmds.setKeyframe(attList, t=(endF))
        if mode=="orient":
            cons = cmds.orientConstraint(sel, worldCtrl)[0]
            cmds.setKeyframe(attList, t=(endF))
        if mode=="parent":
            cons = cmds.parentConstraint(sel, worldCtrl)[0]
            cmds.setKeyframe(attList, t=(endF))
        cmds.delete(cons)   
    """
    
    for sel in selList:        
        #Point
        if mode=="point":
            try:
                for worldCtrl, sel in zip(worldCtrlList, selList ):
                    cmds.pointConstraint(worldCtrl, sel)
            except:
                cmds.delete(worldCtrl)
                cmds.warning(u"エラーが発生しました。それ、ロックかかっていません？")
            
        #Orient       
        if mode=="orient":
            try:
                for worldCtrl, sel in zip(worldCtrlList, selList ):
                    cmds.orientConstraint(worldCtrl, sel)
                    
            except:
                cmds.delete(worldCtrl)
                cmds.warning(u"エラーが発生しました。それ、ロックかかっていません？")
                            
        #Parent        
        if mode=="parent":
            try:
                for worldCtrl, sel in zip(worldCtrlList, selList ):
                    cmds.parentConstraint(worldCtrl, sel)
            except:
                cmds.delete(worldCtrl)
                cmds.warning(u"エラーが発生しました。それ、ロックかかっていません？")
    cmds.select(worldCtrlList)
    cmds.filterCurve()#最後にカーブフィルターをかける
#Return
def returnBake():
        startF = cmds.playbackOptions(q=True,minTime=True)
        endF = cmds.playbackOptions(q=True,maxTime=True)
        attList = []
        blendList = []
        selList = cmds.ls(sl=True)
        
        for sel in cmds.ls(sl=True):
            if sel.count("_World"):
                t_cons =  cmds.listConnections(sel, type="pointConstraint")
                if t_cons !=  None:
                    returnTarget = cmds.listRelatives(t_cons[0], path=True, parent=True)[0]
                    if "_World" in returnTarget:pass
                    else:
                        attList.append( returnTarget + '.t' )
                        blendList.append( returnTarget + ".blendPoint1")


                r_cons =  cmds.listConnections(sel, type="orientConstraint")
                if r_cons !=  None:
                    for returnTarget in cmds.listRelatives(r_cons[0], path=True, parent=True):
                        if "_World" in returnTarget:pass
                        else:
                            attList.append( returnTarget + '.r' )
                            blendList.append( returnTarget + ".blendOrient1")
               
                                            
                p_cons =  cmds.listConnections(sel, type="parentConstraint")             
                if p_cons !=  None:
                    returnTarget = cmds.listRelatives(p_cons[0], path=True, parent=True)[0]
                    for returnTarget in cmds.listRelatives(p_cons[0], path=True, parent=True):
                        if "_World" in returnTarget:pass
                        else:
                            attList.extend([returnTarget+".t",  returnTarget+".r"])
                            blendList.append( returnTarget + ".blendParent1")

        if len(attList) != 0:
            bs = cmds.checkBox("bakeSimulation", q=1, v=1)
            sbtime = cmds.intFieldGrp("sampleBy", q=1, v1=1) 
            cmds.bakeResults(attList, t=(startF,endF), simulation=bs, sampleBy=(sbtime) )
            cmds.select(attList)
            cmds.filterCurve()
            cmds.select(cl=True)
            if cmds.checkBox("deleteBlend", q=True, v=True):
                    try:
                        for blend in blendList:
                            cmds.deleteAttr( blend )
                    except:pass    
            cmds.delete(selList)
        else:cmds.warning(u"Returnできるノードが選択に含まれていません")
         
def createCurve(curvetype,name, size):
    a = 1*size
    b = -1*size
    if curvetype == "Locator": 
        cmds.spaceLocator(n=name)
            
    elif curvetype == "cube":
        cmds.curve(n=name, d=1, p=[(a, a, a), (a, a, b), (b, a, b), (b, b, b), (a, b, b,),
        (a, a, b), (b, a, b), (b, a, a), (a, a, a), (a, b, a), (a, b, b), (b, b, b),
         (b, b, a), (a, b, a), (b, b, a), (b, a, a)])

    elif curvetype == "circle8":
        cmds.circle (n=name, o=True, nr=( 0, a, 0) , r=a ,sections=8)

    elif curvetype == "rombus":
        cmds.curve(n=name,d=1, p=[(0, a, 0), (a, 0, 0), (0, 0, a), (b, 0, 0), (0, 0, b), (0, a, 0), 
        (0, 0, a), (0, b, 0), (0, 0, b), (a, 0, 0), (0, a, 0), (b, 0, 0), (0, b, 0), (a, 0, 0)])

    elif curvetype == "pyramid":
        cmds.curve(n=name,d=1, p=[(0, a*2, 0), (a, 0, b), (b, 0, b), (0, a*2, 0), 
        (b, 0, a), (a, 0, a), (0, a*2, 0), (a, 0, b), (a, 0, a), (b, 0, a), (b, 0, b)]) 
          
    else:pass
    
    return name
#UI
def MoxLocaltoWorld():
    if cmds.window('MoxLocaltoWorld', exists=True):
        cmds.deleteUI('MoxLocaltoWorld')
        
    cmds.window('MoxLocaltoWorld', menuBarVisible=True, tlb=True, s=1, t="Mox Local to World", resizeToFitChildren=1, mnb=1, mxb=0)
    cmds.columnLayout('MainColumnLayout', adjustableColumn=True, rowSpacing=5, columnAttach=["both",5])
    
    cmds.checkBox("deleteBlend", l="deleteBlend at return", v=True)
    
    cmds.rowLayout(nc=4)
    cmds.text("shape")    
    shapes = cmds.optionMenu('ShapeType', w=70)
    for shape in shapeList:
        cmds.menuItem( label=shape)
    cmds.optionMenu('ShapeType', e=True, sl=1)
    cmds.text("ctrlsize", l="    size")
    cmds.floatField("ctrlsize",  v=10, w=40, pre=1, step=0.1)
    cmds.setParent("..")
        

    #cmds.rowLayout(nc=5)
    #cmds.button("start", c="setTimefield('start')")
    #cmds.intField("start",  v=0, w=50)
    #cmds.text("     ")
    #cmds.intField("end", v=0, w=50 )
    #cmds.button("end", c="setTimefield('end')")
    #cmds.setParent("..")
    
    #cmds.checkBox('timeslider', label="Time Slider", v=True)
    #cmds.checkBox('Freeze', label="Freeze Transformation")
    cmds.checkBox("bakeSimulation",v=1)
    cmds.intFieldGrp("sampleBy", label="bakeSampleBy",numberOfFields=1, v1=1, cw2=[80,50])
    
    cmds.rowLayout(nc=4)
    cmds.button(l="Point", c='MoxLocaltoWorld.main("point")', w=40)
    cmds.button(l="Orient", c='MoxLocaltoWorld.main("orient")' )
    cmds.button(l="Parent", c='MoxLocaltoWorld.main("parent")' )
    cmds.button(l="Return", c='MoxLocaltoWorld.returnBake()', bgc=[0.8, 0.8, 0.8] )
    cmds.setParent('..')
  
    cmds.showWindow('MoxLocaltoWorld')

MoxLocaltoWorld()